//+------------------------------------------------------------------+
//|                                                           x4.mq4 |
//|                                                      Coders Guru |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+

#property copyright "Coders Guru"
#property link      "http://www.forex-tsd.com"

//---- Includes
#include <stdlib.mqh>

//---- Trades limits
extern double    TakeProfit = 10;
extern double    StopLoss = 30;
extern int       Slippage = 5;

double    Lots = 0.1;
int      MagicNumber = 21142704;
string   ExpertComment = "x4";
int CurOrderType = OP_BUY;

//+------------------------------------------------------------------
int init()
{

   return(0); 
}
int deinit() {return(0);}

//+------------------------------------------------------------------+
bool isNewSymbol(string current_symbol)
  {
   //loop through all the opened order and compare the symbols
   int total  = OrdersTotal();
   for(int cnt = 0 ; cnt < total ; cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      string selected_symbol = OrderSymbol();
      if (current_symbol == selected_symbol && OrderMagicNumber()==MagicNumber)
      return (False);
    }
    return (True);
}
//+------------------------------------------------------------------+
int start()
{
   int cnt, ticket, total,n;
   
   total  = OrdersTotal();
   
   double lastprofit = GetLastProfit();
   
   if (lastprofit != 0 && lastprofit >= TakeProfit*Point)
   {
      if (CurOrderType == OP_BUY) CurOrderType = OP_SELL;
      else if (CurOrderType == OP_SELL) CurOrderType = OP_BUY;
      Lots = 0.1;
   }
   
   if (lastprofit != 0 && lastprofit <= StopLoss*Point)  
   {
      Lots = 0.4;
   }
   
   if(total < 1 || isNewSymbol(Symbol())) 
     {
            
            OpenOrder(CurOrderType);
            return(0);
     }
}    
//+------------------------------------------------------------------+

int OpenOrder(int type)
{
   if(type==OP_BUY)
      return (OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,ExpertComment,MagicNumber,0,Green));
   if(type==OP_SELL)   
      return (OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,Bid-TakeProfit*Point,ExpertComment,MagicNumber,0,Red));
}

double GetLastProfit()
{
   int total = HistoryTotal();
   
   datetime cur_order = 0;
   datetime last_order=0;
   double profit=0;
      
   for(int cnt = 0 ; cnt < total ; cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY);
       if (OrderMagicNumber() == MagicNumber)
       {
         cur_order = OrderCloseTime();
         if(cur_order>last_order)
         {
            last_order = cur_order;
            profit = OrderProfit();
         }
       }
   }
   return (profit);
}
